Index: issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h	(revision 15431)
+++ issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h	(revision 15432)
@@ -169,5 +169,4 @@
 	MeshAverageVertexConnectivityEnum,
 	MeshDimensionEnum,
-	MeshEdgesEnum,
 	MeshElementconnectivityEnum,
 	MeshElementonbedEnum,
@@ -176,5 +175,4 @@
 	MeshElementsEnum,
 	MeshLowerelementsEnum,
-	MeshNumberofedgesEnum,
 	MeshNumberofelements2dEnum,
 	MeshNumberofelementsEnum,
Index: issm/trunk-jpl/src/c/shared/Enum/EnumToStringx.cpp
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/EnumToStringx.cpp	(revision 15431)
+++ issm/trunk-jpl/src/c/shared/Enum/EnumToStringx.cpp	(revision 15432)
@@ -177,5 +177,4 @@
 		case MeshAverageVertexConnectivityEnum : return "MeshAverageVertexConnectivity";
 		case MeshDimensionEnum : return "MeshDimension";
-		case MeshEdgesEnum : return "MeshEdges";
 		case MeshElementconnectivityEnum : return "MeshElementconnectivity";
 		case MeshElementonbedEnum : return "MeshElementonbed";
@@ -184,5 +183,4 @@
 		case MeshElementsEnum : return "MeshElements";
 		case MeshLowerelementsEnum : return "MeshLowerelements";
-		case MeshNumberofedgesEnum : return "MeshNumberofedges";
 		case MeshNumberofelements2dEnum : return "MeshNumberofelements2d";
 		case MeshNumberofelementsEnum : return "MeshNumberofelements";
Index: issm/trunk-jpl/src/c/shared/Enum/StringToEnumx.cpp
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/StringToEnumx.cpp	(revision 15431)
+++ issm/trunk-jpl/src/c/shared/Enum/StringToEnumx.cpp	(revision 15432)
@@ -180,5 +180,4 @@
 	      else if (strcmp(name,"MeshAverageVertexConnectivity")==0) return MeshAverageVertexConnectivityEnum;
 	      else if (strcmp(name,"MeshDimension")==0) return MeshDimensionEnum;
-	      else if (strcmp(name,"MeshEdges")==0) return MeshEdgesEnum;
 	      else if (strcmp(name,"MeshElementconnectivity")==0) return MeshElementconnectivityEnum;
 	      else if (strcmp(name,"MeshElementonbed")==0) return MeshElementonbedEnum;
@@ -187,5 +186,4 @@
 	      else if (strcmp(name,"MeshElements")==0) return MeshElementsEnum;
 	      else if (strcmp(name,"MeshLowerelements")==0) return MeshLowerelementsEnum;
-	      else if (strcmp(name,"MeshNumberofedges")==0) return MeshNumberofedgesEnum;
 	      else if (strcmp(name,"MeshNumberofelements2d")==0) return MeshNumberofelements2dEnum;
 	      else if (strcmp(name,"MeshNumberofelements")==0) return MeshNumberofelementsEnum;
@@ -260,10 +258,10 @@
 	      else if (strcmp(name,"ThermalIsenthalpy")==0) return ThermalIsenthalpyEnum;
 	      else if (strcmp(name,"GiaMantleViscosity")==0) return GiaMantleViscosityEnum;
+	      else if (strcmp(name,"GiaLithosphereThickness")==0) return GiaLithosphereThicknessEnum;
+	      else if (strcmp(name,"Thickness")==0) return ThicknessEnum;
          else stage=3;
    }
    if(stage==3){
-	      if (strcmp(name,"GiaLithosphereThickness")==0) return GiaLithosphereThicknessEnum;
-	      else if (strcmp(name,"Thickness")==0) return ThicknessEnum;
-	      else if (strcmp(name,"TimesteppingStartTime")==0) return TimesteppingStartTimeEnum;
+	      if (strcmp(name,"TimesteppingStartTime")==0) return TimesteppingStartTimeEnum;
 	      else if (strcmp(name,"TimesteppingFinalTime")==0) return TimesteppingFinalTimeEnum;
 	      else if (strcmp(name,"TimesteppingCflCoefficient")==0) return TimesteppingCflCoefficientEnum;
@@ -383,10 +381,10 @@
 	      else if (strcmp(name,"VectorParam")==0) return VectorParamEnum;
 	      else if (strcmp(name,"Riftfront")==0) return RiftfrontEnum;
+	      else if (strcmp(name,"RiftfrontType")==0) return RiftfrontTypeEnum;
+	      else if (strcmp(name,"Segment")==0) return SegmentEnum;
          else stage=4;
    }
    if(stage==4){
-	      if (strcmp(name,"RiftfrontType")==0) return RiftfrontTypeEnum;
-	      else if (strcmp(name,"Segment")==0) return SegmentEnum;
-	      else if (strcmp(name,"SegmentRiftfront")==0) return SegmentRiftfrontEnum;
+	      if (strcmp(name,"SegmentRiftfront")==0) return SegmentRiftfrontEnum;
 	      else if (strcmp(name,"SpcDynamic")==0) return SpcDynamicEnum;
 	      else if (strcmp(name,"SpcStatic")==0) return SpcStaticEnum;
@@ -506,10 +504,10 @@
 	      else if (strcmp(name,"BoolElementResult")==0) return BoolElementResultEnum;
 	      else if (strcmp(name,"BoolExternalResult")==0) return BoolExternalResultEnum;
+	      else if (strcmp(name,"DoubleElementResult")==0) return DoubleElementResultEnum;
+	      else if (strcmp(name,"DoubleExternalResult")==0) return DoubleExternalResultEnum;
          else stage=5;
    }
    if(stage==5){
-	      if (strcmp(name,"DoubleElementResult")==0) return DoubleElementResultEnum;
-	      else if (strcmp(name,"DoubleExternalResult")==0) return DoubleExternalResultEnum;
-	      else if (strcmp(name,"DoubleMatExternalResult")==0) return DoubleMatExternalResultEnum;
+	      if (strcmp(name,"DoubleMatExternalResult")==0) return DoubleMatExternalResultEnum;
 	      else if (strcmp(name,"IntExternalResult")==0) return IntExternalResultEnum;
 	      else if (strcmp(name,"J")==0) return JEnum;
Index: issm/trunk-jpl/src/m/classes/mesh.m
===================================================================
--- issm/trunk-jpl/src/m/classes/mesh.m	(revision 15431)
+++ issm/trunk-jpl/src/m/classes/mesh.m	(revision 15432)
@@ -116,18 +116,12 @@
 					if md.prognostic.stabilization==3,
 						md = checkfield(md,'mesh.dimension','values',2,'message','Discontinuous Galerkin only supported for 2d meshes');
-						md = checkfield(md,'mesh.edges','size',[NaN 4]);
-						md = checkfield(md,'mesh.edges(:,1:3)','>',0);
 					end
 				case BalancethicknessSolutionEnum(),
 					if md.balancethickness.stabilization==3,
 						md = checkfield(md,'mesh.dimension','values',2,'message','Discontinuous Galerkin only supported for 2d meshes');
-						md = checkfield(md,'mesh.edges','size',[NaN 4]);
-						md = checkfield(md,'mesh.edges(:,1:3)','>',0);
 					end
 				case TransientSolutionEnum(),
 					if md.transient.isprognostic & md.prognostic.stabilization==3,
 						md = checkfield(md,'mesh.dimension','values',2,'message','Discontinuous Galerkin only supported for 2d meshes');
-						md = checkfield(md,'mesh.edges','size',[NaN 4]);
-						md = checkfield(md,'mesh.edges(:,1:3)','>',0);
 					end
 				case ThermalSolutionEnum(),
@@ -196,5 +190,4 @@
 			WriteData(fid,'object',obj,'fieldname','numberofelements','format','Integer');
 			WriteData(fid,'object',obj,'fieldname','numberofvertices','format','Integer');
-			WriteData(fid,'object',obj,'fieldname','numberofedges','format','Integer');
 			WriteData(fid,'object',obj,'fieldname','elementonbed','format','BooleanMat','mattype',2);
 			WriteData(fid,'object',obj,'fieldname','elementonsurface','format','BooleanMat','mattype',2);
@@ -203,5 +196,4 @@
 			WriteData(fid,'object',obj,'fieldname','lowerelements','format','DoubleMat','mattype',2);
 			WriteData(fid,'object',obj,'fieldname','upperelements','format','DoubleMat','mattype',2);
-			WriteData(fid,'object',obj,'fieldname','edges','format','DoubleMat','mattype',3);
 			WriteData(fid,'object',obj,'fieldname','elementconnectivity','format','DoubleMat','mattype',3);
 			WriteData(fid,'object',obj,'fieldname','average_vertex_connectivity','format','Integer');
Index: issm/trunk-jpl/src/m/classes/mesh.py
===================================================================
--- issm/trunk-jpl/src/m/classes/mesh.py	(revision 15431)
+++ issm/trunk-jpl/src/m/classes/mesh.py	(revision 15432)
@@ -153,16 +153,10 @@
 			if md.prognostic.stabilization==3:
 				md = checkfield(md,'mesh.dimension','values',2,'message',"Discontinuous Galerkin only supported for 2d meshes")
-				md = checkfield(md,'mesh.edges','size',[float('NaN'),4])
-				md = checkfield(md,'mesh.edges[:,1:3]','>',0)
 		elif solution==BalancethicknessSolutionEnum():
 			if md.balancethickness.stabilization==3:
 				md = checkfield(md,'mesh.dimension','values',2,'message',"Discontinuous Galerkin only supported for 2d meshes")
-				md = checkfield(md,'mesh.edges','size',[float('NaN'),4])
-				md = checkfield(md,'mesh.edges[:,1:3]','>',0)
 		elif solution==TransientSolutionEnum():
 			if md.transient.isprognostic and md.prognostic.stabilization==3:
 				md = checkfield(md,'mesh.dimension','values',2,'message',"Discontinuous Galerkin only supported for 2d meshes")
-				md = checkfield(md,'mesh.edges','size',[float('NaN'),4])
-				md = checkfield(md,'mesh.edges[:,1:3]','>',0)
 		elif solution==ThermalSolutionEnum():
 			md = checkfield(md,'mesh.dimension','values',3,'message','thermal solution only supported on 3d meshes')
@@ -179,5 +173,4 @@
 		WriteData(fid,'object',self,'fieldname','numberofelements','format','Integer')
 		WriteData(fid,'object',self,'fieldname','numberofvertices','format','Integer')
-		WriteData(fid,'object',self,'fieldname','numberofedges','format','Integer')
 		WriteData(fid,'object',self,'fieldname','elementonbed','format','BooleanMat','mattype',2)
 		WriteData(fid,'object',self,'fieldname','elementonsurface','format','BooleanMat','mattype',2)
@@ -186,5 +179,4 @@
 		WriteData(fid,'object',self,'fieldname','lowerelements','format','DoubleMat','mattype',2)
 		WriteData(fid,'object',self,'fieldname','upperelements','format','DoubleMat','mattype',2)
-		WriteData(fid,'object',self,'fieldname','edges','format','DoubleMat','mattype',3)
 		WriteData(fid,'object',self,'fieldname','elementconnectivity','format','DoubleMat','mattype',3)
 		WriteData(fid,'object',self,'fieldname','average_vertex_connectivity','format','Integer')
Index: issm/trunk-jpl/src/m/enum/EnumDefinitions.py
===================================================================
--- issm/trunk-jpl/src/m/enum/EnumDefinitions.py	(revision 15431)
+++ issm/trunk-jpl/src/m/enum/EnumDefinitions.py	(revision 15432)
@@ -2249,18 +2249,4 @@
 	return StringToEnum('MeshDimension')[0]
 
-def MeshEdgesEnum():
-	"""
-	MESHEDGESENUM - Enum of MeshEdges
-
-	WARNING: DO NOT MODIFY THIS FILE
-				this file has been automatically generated by src/c/shared/Enum/Synchronize.sh
-				Please read src/c/shared/Enum/README for more information
-
-	   Usage:
-	      macro=MeshEdgesEnum()
-	"""
-
-	return StringToEnum('MeshEdges')[0]
-
 def MeshElementconnectivityEnum():
 	"""
@@ -2347,18 +2333,4 @@
 	return StringToEnum('MeshLowerelements')[0]
 
-def MeshNumberofedgesEnum():
-	"""
-	MESHNUMBEROFEDGESENUM - Enum of MeshNumberofedges
-
-	WARNING: DO NOT MODIFY THIS FILE
-				this file has been automatically generated by src/c/shared/Enum/Synchronize.sh
-				Please read src/c/shared/Enum/README for more information
-
-	   Usage:
-	      macro=MeshNumberofedgesEnum()
-	"""
-
-	return StringToEnum('MeshNumberofedges')[0]
-
 def MeshNumberofelements2dEnum():
 	"""
@@ -7889,4 +7861,4 @@
 	"""
 
-	return 562
-
+	return 560
+
Index: issm/trunk-jpl/src/m/enum/MaximumNumberOfEnums.m
===================================================================
--- issm/trunk-jpl/src/m/enum/MaximumNumberOfEnums.m	(revision 15431)
+++ issm/trunk-jpl/src/m/enum/MaximumNumberOfEnums.m	(revision 15432)
@@ -9,3 +9,3 @@
 %      macro=MaximumNumberOfEnums()
 
-macro=562;
+macro=560;
Index: issm/trunk-jpl/src/m/enum/MeshEdgesEnum.m
===================================================================
--- issm/trunk-jpl/src/m/enum/MeshEdgesEnum.m	(revision 15431)
+++ 	(revision )
@@ -1,11 +1,0 @@
-function macro=MeshEdgesEnum()
-%MESHEDGESENUM - Enum of MeshEdges
-%
-%   WARNING: DO NOT MODIFY THIS FILE
-%            this file has been automatically generated by src/c/shared/Enum/Synchronize.sh
-%            Please read src/c/shared/Enum/README for more information
-%
-%   Usage:
-%      macro=MeshEdgesEnum()
-
-macro=StringToEnum('MeshEdges');
Index: issm/trunk-jpl/src/m/enum/MeshNumberofedgesEnum.m
===================================================================
--- issm/trunk-jpl/src/m/enum/MeshNumberofedgesEnum.m	(revision 15431)
+++ 	(revision )
@@ -1,11 +1,0 @@
-function macro=MeshNumberofedgesEnum()
-%MESHNUMBEROFEDGESENUM - Enum of MeshNumberofedges
-%
-%   WARNING: DO NOT MODIFY THIS FILE
-%            this file has been automatically generated by src/c/shared/Enum/Synchronize.sh
-%            Please read src/c/shared/Enum/README for more information
-%
-%   Usage:
-%      macro=MeshNumberofedgesEnum()
-
-macro=StringToEnum('MeshNumberofedges');
Index: issm/trunk-jpl/src/m/enum/PentaP1InputEnum.m
===================================================================
--- issm/trunk-jpl/src/m/enum/PentaP1InputEnum.m	(revision 15431)
+++ 	(revision )
@@ -1,11 +1,0 @@
-function macro=PentaP1InputEnum()
-%PENTAP1INPUTENUM - Enum of PentaP1Input
-%
-%   WARNING: DO NOT MODIFY THIS FILE
-%            this file has been automatically generated by src/c/shared/Enum/Synchronize.sh
-%            Please read src/c/shared/Enum/README for more information
-%
-%   Usage:
-%      macro=PentaP1InputEnum()
-
-macro=StringToEnum('PentaP1Input');