Index: issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h	(revision 15436)
+++ issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h	(revision 15437)
@@ -72,4 +72,5 @@
 	FlowequationIsstokesEnum,
 	FlowequationFeStokesEnum,
+	FlowequationFeSsaEnum,
 	FlowequationVertexEquationEnum,
 	FrictionCoefficientEnum,
Index: issm/trunk-jpl/src/c/shared/Enum/EnumToStringx.cpp
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/EnumToStringx.cpp	(revision 15436)
+++ issm/trunk-jpl/src/c/shared/Enum/EnumToStringx.cpp	(revision 15437)
@@ -80,4 +80,5 @@
 		case FlowequationIsstokesEnum : return "FlowequationIsstokes";
 		case FlowequationFeStokesEnum : return "FlowequationFeStokes";
+		case FlowequationFeSsaEnum : return "FlowequationFeSsa";
 		case FlowequationVertexEquationEnum : return "FlowequationVertexEquation";
 		case FrictionCoefficientEnum : return "FrictionCoefficient";
Index: issm/trunk-jpl/src/c/shared/Enum/StringToEnumx.cpp
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/StringToEnumx.cpp	(revision 15436)
+++ issm/trunk-jpl/src/c/shared/Enum/StringToEnumx.cpp	(revision 15437)
@@ -80,4 +80,5 @@
 	      else if (strcmp(name,"FlowequationIsstokes")==0) return FlowequationIsstokesEnum;
 	      else if (strcmp(name,"FlowequationFeStokes")==0) return FlowequationFeStokesEnum;
+	      else if (strcmp(name,"FlowequationFeSsa")==0) return FlowequationFeSsaEnum;
 	      else if (strcmp(name,"FlowequationVertexEquation")==0) return FlowequationVertexEquationEnum;
 	      else if (strcmp(name,"FrictionCoefficient")==0) return FrictionCoefficientEnum;
@@ -136,9 +137,9 @@
 	      else if (strcmp(name,"InversionIncompleteAdjoint")==0) return InversionIncompleteAdjointEnum;
 	      else if (strcmp(name,"InversionMaxParameters")==0) return InversionMaxParametersEnum;
-	      else if (strcmp(name,"InversionMaxiterPerStep")==0) return InversionMaxiterPerStepEnum;
          else stage=2;
    }
    if(stage==2){
-	      if (strcmp(name,"InversionMinParameters")==0) return InversionMinParametersEnum;
+	      if (strcmp(name,"InversionMaxiterPerStep")==0) return InversionMaxiterPerStepEnum;
+	      else if (strcmp(name,"InversionMinParameters")==0) return InversionMinParametersEnum;
 	      else if (strcmp(name,"InversionNsteps")==0) return InversionNstepsEnum;
 	      else if (strcmp(name,"InversionNumControlParameters")==0) return InversionNumControlParametersEnum;
@@ -259,9 +260,9 @@
 	      else if (strcmp(name,"GiaLithosphereThickness")==0) return GiaLithosphereThicknessEnum;
 	      else if (strcmp(name,"Thickness")==0) return ThicknessEnum;
-	      else if (strcmp(name,"TimesteppingStartTime")==0) return TimesteppingStartTimeEnum;
          else stage=3;
    }
    if(stage==3){
-	      if (strcmp(name,"TimesteppingFinalTime")==0) return TimesteppingFinalTimeEnum;
+	      if (strcmp(name,"TimesteppingStartTime")==0) return TimesteppingStartTimeEnum;
+	      else if (strcmp(name,"TimesteppingFinalTime")==0) return TimesteppingFinalTimeEnum;
 	      else if (strcmp(name,"TimesteppingCflCoefficient")==0) return TimesteppingCflCoefficientEnum;
 	      else if (strcmp(name,"TimesteppingTimeAdapt")==0) return TimesteppingTimeAdaptEnum;
@@ -382,9 +383,9 @@
 	      else if (strcmp(name,"RiftfrontType")==0) return RiftfrontTypeEnum;
 	      else if (strcmp(name,"Segment")==0) return SegmentEnum;
-	      else if (strcmp(name,"SegmentRiftfront")==0) return SegmentRiftfrontEnum;
          else stage=4;
    }
    if(stage==4){
-	      if (strcmp(name,"SpcDynamic")==0) return SpcDynamicEnum;
+	      if (strcmp(name,"SegmentRiftfront")==0) return SegmentRiftfrontEnum;
+	      else if (strcmp(name,"SpcDynamic")==0) return SpcDynamicEnum;
 	      else if (strcmp(name,"SpcStatic")==0) return SpcStaticEnum;
 	      else if (strcmp(name,"SpcTransient")==0) return SpcTransientEnum;
@@ -505,9 +506,9 @@
 	      else if (strcmp(name,"DoubleElementResult")==0) return DoubleElementResultEnum;
 	      else if (strcmp(name,"DoubleExternalResult")==0) return DoubleExternalResultEnum;
-	      else if (strcmp(name,"DoubleMatExternalResult")==0) return DoubleMatExternalResultEnum;
          else stage=5;
    }
    if(stage==5){
-	      if (strcmp(name,"IntExternalResult")==0) return IntExternalResultEnum;
+	      if (strcmp(name,"DoubleMatExternalResult")==0) return DoubleMatExternalResultEnum;
+	      else if (strcmp(name,"IntExternalResult")==0) return IntExternalResultEnum;
 	      else if (strcmp(name,"J")==0) return JEnum;
 	      else if (strcmp(name,"Patch")==0) return PatchEnum;
Index: issm/trunk-jpl/src/m/classes/flowequation.m
===================================================================
--- issm/trunk-jpl/src/m/classes/flowequation.m	(revision 15436)
+++ issm/trunk-jpl/src/m/classes/flowequation.m	(revision 15437)
@@ -11,4 +11,5 @@
 		isstokes             = 0;
 		fe_stokes            = 0;
+		fe_ssa               = 0;
 		vertex_equation      = NaN;
 		element_equation     = NaN;
@@ -80,4 +81,5 @@
 			WriteData(fid,'object',obj,'fieldname','isstokes','format','Boolean');
 			WriteData(fid,'object',obj,'fieldname','fe_stokes','format','Integer');
+			WriteData(fid,'object',obj,'fieldname','fe_ssa','format','Integer');
 			WriteData(fid,'object',obj,'fieldname','bordermacayeal','format','DoubleMat','mattype',1);
 			WriteData(fid,'object',obj,'fieldname','borderpattyn','format','DoubleMat','mattype',1);
Index: issm/trunk-jpl/src/m/classes/flowequation.py
===================================================================
--- issm/trunk-jpl/src/m/classes/flowequation.py	(revision 15436)
+++ issm/trunk-jpl/src/m/classes/flowequation.py	(revision 15437)
@@ -16,14 +16,15 @@
 	def __init__(self): # {{{
 		
-		self.ismacayealpattyn     = 0
-		self.ishutter             = 0
-		self.isl1l2               = 0
-		self.isstokes             = 0
-		self.fe_stokes            = 0
-		self.vertex_equation      = float('NaN')
-		self.element_equation     = float('NaN')
-		self.bordermacayeal       = float('NaN')
-		self.borderpattyn         = float('NaN')
-		self.borderstokes         = float('NaN')
+		self.ismacayealpattyn = 0
+		self.ishutter         = 0
+		self.isl1l2           = 0
+		self.isstokes         = 0
+		self.fe_stokes        = 0
+		self.fe_ssa           = 0
+		self.vertex_equation  = float('NaN')
+		self.element_equation = float('NaN')
+		self.bordermacayeal   = float('NaN')
+		self.borderpattyn     = float('NaN')
+		self.borderstokes     = float('NaN')
 
 		#set defaults
@@ -80,4 +81,5 @@
 		WriteData(fid,'object',self,'fieldname','isstokes','format','Boolean')
 		WriteData(fid,'object',self,'fieldname','fe_stokes','format','Integer')
+		WriteData(fid,'object',self,'fieldname','fe_ssa','format','Integer')
 		WriteData(fid,'object',self,'fieldname','bordermacayeal','format','DoubleMat','mattype',1)
 		WriteData(fid,'object',self,'fieldname','borderpattyn','format','DoubleMat','mattype',1)
Index: issm/trunk-jpl/src/m/enum/EnumDefinitions.py
===================================================================
--- issm/trunk-jpl/src/m/enum/EnumDefinitions.py	(revision 15436)
+++ issm/trunk-jpl/src/m/enum/EnumDefinitions.py	(revision 15437)
@@ -891,4 +891,18 @@
 	return StringToEnum('FlowequationFeStokes')[0]
 
+def FlowequationFeSsaEnum():
+	"""
+	FLOWEQUATIONFESSAENUM - Enum of FlowequationFeSsa
+
+	WARNING: DO NOT MODIFY THIS FILE
+				this file has been automatically generated by src/c/shared/Enum/Synchronize.sh
+				Please read src/c/shared/Enum/README for more information
+
+	   Usage:
+	      macro=FlowequationFeSsaEnum()
+	"""
+
+	return StringToEnum('FlowequationFeSsa')[0]
+
 def FlowequationVertexEquationEnum():
 	"""
@@ -7847,4 +7861,4 @@
 	"""
 
-	return 559
-
+	return 560
+
Index: issm/trunk-jpl/src/m/enum/FlowequationFeSsaEnum.m
===================================================================
--- issm/trunk-jpl/src/m/enum/FlowequationFeSsaEnum.m	(revision 15437)
+++ issm/trunk-jpl/src/m/enum/FlowequationFeSsaEnum.m	(revision 15437)
@@ -0,0 +1,11 @@
+function macro=FlowequationFeSsaEnum()
+%FLOWEQUATIONFESSAENUM - Enum of FlowequationFeSsa
+%
+%   WARNING: DO NOT MODIFY THIS FILE
+%            this file has been automatically generated by src/c/shared/Enum/Synchronize.sh
+%            Please read src/c/shared/Enum/README for more information
+%
+%   Usage:
+%      macro=FlowequationFeSsaEnum()
+
+macro=StringToEnum('FlowequationFeSsa');
Index: issm/trunk-jpl/src/m/enum/MaximumNumberOfEnums.m
===================================================================
--- issm/trunk-jpl/src/m/enum/MaximumNumberOfEnums.m	(revision 15436)
+++ issm/trunk-jpl/src/m/enum/MaximumNumberOfEnums.m	(revision 15437)
@@ -9,3 +9,3 @@
 %      macro=MaximumNumberOfEnums()
 
-macro=559;
+macro=560;