Index: issm/trunk-jpl/src/m/plot/plot_elementstype.m
===================================================================
--- issm/trunk-jpl/src/m/plot/plot_elementstype.m	(revision 15512)
+++ issm/trunk-jpl/src/m/plot/plot_elementstype.m	(revision 15564)
@@ -18,5 +18,5 @@
 
 if is2d
-	%Hutter elements
+	%SIA elements
 	posH=find(data==1);
 	A=elements(posH,1); B=elements(posH,2); C=elements(posH,3); 
@@ -26,21 +26,21 @@
 	A=elements(posM,1); B=elements(posM,2); C=elements(posM,3); 
 	p2=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',2,'FaceColor','flat','EdgeColor',edgecolor);
-	%Pattyn element
+	%HO element
 	posP=find(data==3);
 	A=elements(posP,1); B=elements(posP,2); C=elements(posP,3); 
 	p3=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',3,'FaceColor','flat','EdgeColor',edgecolor);
-	%MacAyealPattyn element
+	%MacAyealHO element
 	posMP=find(data==5);
 	A=elements(posMP,1); B=elements(posMP,2); C=elements(posMP,3); 
 	p5=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',5,'FaceColor','flat','EdgeColor',edgecolor);
-	%Stokes elements
+	%FS elements
 	posS=find(data==4);
 	A=elements(posS,1); B=elements(posS,2); C=elements(posS,3); 
 	p6=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',4,'FaceColor','flat','EdgeColor',edgecolor);
-	%MacAyealStokes elements
+	%MacAyealFS elements
 	posMS=find(data==6);
 	A=elements(posMS,1); B=elements(posMS,2); C=elements(posMS,3); 
 	p7=patch( 'Faces', [A B C], 'Vertices', [x y z],'CData',6,'FaceColor','flat','EdgeColor',edgecolor);
-	%PattynStokes elements
+	%HOFS elements
 	posPS=find(data==7);
 	A=elements(posPS,1); B=elements(posPS,2); C=elements(posPS,3); 
@@ -52,9 +52,9 @@
 
 	legend([p1 p2 p3 p5 p6 p7 p8 p9],...
-		'Hutter''s elements','MacAyeal''s elements','Pattyn''s elements',...
-		'MacAyealPattyn''s elements','Stokes''s elements','MacAyealStokes''s elements','PattynStokes''s elements','None element');
+		'SIA''s elements','MacAyeal''s elements','HO''s elements',...
+		'MacAyealHO''s elements','FS''s elements','MacAyealFS''s elements','HOFS''s elements','None element');
 
 else
-	%Hutter elements
+	%SIA elements
 	posH=find(data==1);
 	A=elements(posH,1); B=elements(posH,2); C=elements(posH,3); D=elements(posH,4); E=elements(posH,5); F=elements(posH,6);
@@ -72,5 +72,5 @@
 	patch( 'Faces', [B E F C],'Vertices', [x y z],'CData', 2,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [C A D F],'Vertices', [x y z],'CData', 2,'FaceColor','flat','EdgeColor',edgecolor);
-	%Pattyn elements
+	%HO elements
 	posP=find(data==3);
 	A=elements(posP,1); B=elements(posP,2); C=elements(posP,3); D=elements(posP,4); E=elements(posP,5); F=elements(posP,6);
@@ -80,5 +80,5 @@
 	patch( 'Faces', [B E F C],'Vertices', [x y z],'CData', 3,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [C A D F],'Vertices', [x y z],'CData', 3,'FaceColor','flat','EdgeColor',edgecolor);
-	%Stokes elements
+	%FS elements
 	posS=find(data==4);
 	A=elements(posS,1); B=elements(posS,2); C=elements(posS,3); D=elements(posS,4); E=elements(posS,5); F=elements(posS,6);
@@ -88,5 +88,5 @@
 	patch( 'Faces', [B E F C],'Vertices', [x y z],'CData', 4,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [C A D F],'Vertices', [x y z],'CData', 4,'FaceColor','flat','EdgeColor',edgecolor);
-	%MacAyealPattyn elements
+	%MacAyealHO elements
 	posP=find(data==5);
 	A=elements(posP,1); B=elements(posP,2); C=elements(posP,3); D=elements(posP,4); E=elements(posP,5); F=elements(posP,6);
@@ -96,5 +96,5 @@
 	patch( 'Faces', [B E F C],'Vertices', [x y z],'CData', 5,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [C A D F],'Vertices', [x y z],'CData', 5,'FaceColor','flat','EdgeColor',edgecolor);
-	%PattynStokes elements
+	%HOFS elements
 	PosPS=find(data==7);
 	A=elements(PosPS,1); B=elements(PosPS,2); C=elements(PosPS,3); D=elements(PosPS,4); E=elements(PosPS,5); F=elements(PosPS,6);
@@ -104,5 +104,5 @@
 	patch( 'Faces', [B E F C],'Vertices', [x y z],'CData', 7,'FaceColor','flat','EdgeColor',edgecolor);
 	patch( 'Faces', [C A D F],'Vertices', [x y z],'CData', 7,'FaceColor','flat','EdgeColor',edgecolor);
-	%MacAyealStokes elements
+	%MacAyealFS elements
 	PosMS=find(data==6);
 	A=elements(PosMS,1); B=elements(PosMS,2); C=elements(PosMS,3); D=elements(PosMS,4); E=elements(PosMS,5); F=elements(PosMS,6);
@@ -122,6 +122,6 @@
 
 	legend([p1 p2 p3 p4 p5 p6 p7 p8],...
-		'Hutter''s elements','MacAyeal''s elements','Pattyn''s elements','Stokes''s elements',...
-		'MacAyealPattyn''s elements','PattynStokes''s elements','MacAyealStokes''s elements','None elements');
+		'SIA''s elements','MacAyeal''s elements','HO''s elements','FS''s elements',...
+		'MacAyealHO''s elements','HOFS''s elements','MacAyealFS''s elements','None elements');
 end
 
Index: issm/trunk-jpl/src/m/plot/plot_penalties.m
===================================================================
--- issm/trunk-jpl/src/m/plot/plot_penalties.m	(revision 15512)
+++ issm/trunk-jpl/src/m/plot/plot_penalties.m	(revision 15564)
@@ -40,5 +40,5 @@
 		P2=plot3(x(md.penalties(i,:)),y(md.penalties(i,:)),z(md.penalties(i,:)),'bo-','LineWidth',2,'MarkerSize',8,'MarkerFaceColor','b');
 	end
-	legend([P1 P2],'MacAyeal''s penalized nodes','Pattyn''s penalized nodes');
+	legend([P1 P2],'MacAyeal''s penalized nodes','HO''s penalized nodes');
 end
 