Index: issm/trunk-jpl/src/m/enum/EnumDefinitions.py
===================================================================
--- issm/trunk-jpl/src/m/enum/EnumDefinitions.py	(revision 15767)
+++ issm/trunk-jpl/src/m/enum/EnumDefinitions.py	(revision 15771)
@@ -41,23 +41,23 @@
 def ConstantsYtsEnum(): return StringToEnum("ConstantsYts")[0]
 def DependentObjectEnum(): return StringToEnum("DependentObject")[0]
-def DiagnosticAbstolEnum(): return StringToEnum("DiagnosticAbstol")[0]
-def DiagnosticIcefrontEnum(): return StringToEnum("DiagnosticIcefront")[0]
-def DiagnosticIsnewtonEnum(): return StringToEnum("DiagnosticIsnewton")[0]
-def DiagnosticMaxiterEnum(): return StringToEnum("DiagnosticMaxiter")[0]
-def DiagnosticNumRequestedOutputsEnum(): return StringToEnum("DiagnosticNumRequestedOutputs")[0]
-def DiagnosticPenaltyFactorEnum(): return StringToEnum("DiagnosticPenaltyFactor")[0]
-def DiagnosticReferentialEnum(): return StringToEnum("DiagnosticReferential")[0]
-def DiagnosticReltolEnum(): return StringToEnum("DiagnosticReltol")[0]
-def DiagnosticRequestedOutputsEnum(): return StringToEnum("DiagnosticRequestedOutputs")[0]
-def DiagnosticRestolEnum(): return StringToEnum("DiagnosticRestol")[0]
-def DiagnosticRiftPenaltyLockEnum(): return StringToEnum("DiagnosticRiftPenaltyLock")[0]
-def DiagnosticRiftPenaltyThresholdEnum(): return StringToEnum("DiagnosticRiftPenaltyThreshold")[0]
-def DiagnosticShelfDampeningEnum(): return StringToEnum("DiagnosticShelfDampening")[0]
-def DiagnosticSpcvxEnum(): return StringToEnum("DiagnosticSpcvx")[0]
-def DiagnosticSpcvyEnum(): return StringToEnum("DiagnosticSpcvy")[0]
-def DiagnosticSpcvzEnum(): return StringToEnum("DiagnosticSpcvz")[0]
-def DiagnosticFSreconditioningEnum(): return StringToEnum("DiagnosticFSreconditioning")[0]
-def DiagnosticVertexPairingEnum(): return StringToEnum("DiagnosticVertexPairing")[0]
-def DiagnosticViscosityOvershootEnum(): return StringToEnum("DiagnosticViscosityOvershoot")[0]
+def StressbalanceAbstolEnum(): return StringToEnum("StressbalanceAbstol")[0]
+def StressbalanceIcefrontEnum(): return StringToEnum("StressbalanceIcefront")[0]
+def StressbalanceIsnewtonEnum(): return StringToEnum("StressbalanceIsnewton")[0]
+def StressbalanceMaxiterEnum(): return StringToEnum("StressbalanceMaxiter")[0]
+def StressbalanceNumRequestedOutputsEnum(): return StringToEnum("StressbalanceNumRequestedOutputs")[0]
+def StressbalancePenaltyFactorEnum(): return StringToEnum("StressbalancePenaltyFactor")[0]
+def StressbalanceReferentialEnum(): return StringToEnum("StressbalanceReferential")[0]
+def StressbalanceReltolEnum(): return StringToEnum("StressbalanceReltol")[0]
+def StressbalanceRequestedOutputsEnum(): return StringToEnum("StressbalanceRequestedOutputs")[0]
+def StressbalanceRestolEnum(): return StringToEnum("StressbalanceRestol")[0]
+def StressbalanceRiftPenaltyLockEnum(): return StringToEnum("StressbalanceRiftPenaltyLock")[0]
+def StressbalanceRiftPenaltyThresholdEnum(): return StringToEnum("StressbalanceRiftPenaltyThreshold")[0]
+def StressbalanceShelfDampeningEnum(): return StringToEnum("StressbalanceShelfDampening")[0]
+def StressbalanceSpcvxEnum(): return StringToEnum("StressbalanceSpcvx")[0]
+def StressbalanceSpcvyEnum(): return StringToEnum("StressbalanceSpcvy")[0]
+def StressbalanceSpcvzEnum(): return StringToEnum("StressbalanceSpcvz")[0]
+def StressbalanceFSreconditioningEnum(): return StringToEnum("StressbalanceFSreconditioning")[0]
+def StressbalanceVertexPairingEnum(): return StringToEnum("StressbalanceVertexPairing")[0]
+def StressbalanceViscosityOvershootEnum(): return StringToEnum("StressbalanceViscosityOvershoot")[0]
 def LoadingforceXEnum(): return StringToEnum("LoadingforceX")[0]
 def LoadingforceYEnum(): return StringToEnum("LoadingforceY")[0]
@@ -254,5 +254,5 @@
 def TimesteppingTimeAdaptEnum(): return StringToEnum("TimesteppingTimeAdapt")[0]
 def TimesteppingTimeStepEnum(): return StringToEnum("TimesteppingTimeStep")[0]
-def TransientIsdiagnosticEnum(): return StringToEnum("TransientIsdiagnostic")[0]
+def TransientIsstressbalanceEnum(): return StringToEnum("TransientIsstressbalance")[0]
 def TransientIsgroundinglineEnum(): return StringToEnum("TransientIsgroundingline")[0]
 def TransientIsmasstransportEnum(): return StringToEnum("TransientIsmasstransport")[0]
@@ -278,8 +278,8 @@
 def BedSlopeXAnalysisEnum(): return StringToEnum("BedSlopeXAnalysis")[0]
 def BedSlopeYAnalysisEnum(): return StringToEnum("BedSlopeYAnalysis")[0]
-def DiagnosticHorizAnalysisEnum(): return StringToEnum("DiagnosticHorizAnalysis")[0]
-def DiagnosticSIAAnalysisEnum(): return StringToEnum("DiagnosticSIAAnalysis")[0]
-def DiagnosticSolutionEnum(): return StringToEnum("DiagnosticSolution")[0]
-def DiagnosticVertAnalysisEnum(): return StringToEnum("DiagnosticVertAnalysis")[0]
+def StressbalanceAnalysisEnum(): return StringToEnum("StressbalanceAnalysis")[0]
+def StressbalanceSIAAnalysisEnum(): return StringToEnum("StressbalanceSIAAnalysis")[0]
+def StressbalanceSolutionEnum(): return StringToEnum("StressbalanceSolution")[0]
+def StressbalanceVerticalAnalysisEnum(): return StringToEnum("StressbalanceVerticalAnalysis")[0]
 def EnthalpyAnalysisEnum(): return StringToEnum("EnthalpyAnalysis")[0]
 def EnthalpySolutionEnum(): return StringToEnum("EnthalpySolution")[0]