Index: issm/trunk-jpl/src/m/classes/masstransport.m
===================================================================
--- issm/trunk-jpl/src/m/classes/masstransport.m	(revision 16457)
+++ issm/trunk-jpl/src/m/classes/masstransport.m	(revision 16458)
@@ -84,7 +84,5 @@
 			md = checkfield(md,'masstransport.stabilization','values',[0 1 2 3]);
 			md = checkfield(md,'masstransport.min_thickness','>',0);
-			if ~isempty(md.masstransport.requested_outputs),
-				md = checkfield(md,'masstransport.requested_outputs','size',[1 NaN]);
-			end
+			md = checkfield(md,'masstransport.requested_outputs','stringrow',1);
 
 		end % }}}
Index: issm/trunk-jpl/src/m/classes/masstransport.py
===================================================================
--- issm/trunk-jpl/src/m/classes/masstransport.py	(revision 16457)
+++ issm/trunk-jpl/src/m/classes/masstransport.py	(revision 16458)
@@ -65,6 +65,5 @@
 		md = checkfield(md,'masstransport.stabilization','values',[0,1,2,3])
 		md = checkfield(md,'masstransport.min_thickness','>',0)
-		if md.masstransport.requested_outputs:
-			md = checkfield(md,'masstransport.requested_outputs','cell',1)
+		md = checkfield(md,'masstransport.requested_outputs','stringrow',1)
 
 		return md
Index: issm/trunk-jpl/src/m/classes/steadystate.m
===================================================================
--- issm/trunk-jpl/src/m/classes/steadystate.m	(revision 16457)
+++ issm/trunk-jpl/src/m/classes/steadystate.m	(revision 16458)
@@ -34,4 +34,5 @@
 				md = checkmessage(md,['for a steadystate computation, timestepping.time_step must be zero.']);
 			end
+			md = checkfield(md,'steadystate.requested_outputs','stringrow',1);
 
 			if isnan(md.stressbalance.reltol),
Index: issm/trunk-jpl/src/m/classes/steadystate.py
===================================================================
--- issm/trunk-jpl/src/m/classes/steadystate.py	(revision 16457)
+++ issm/trunk-jpl/src/m/classes/steadystate.py	(revision 16458)
@@ -51,6 +51,5 @@
 			md.checkmessage("for a steadystate computation, stressbalance.reltol (relative convergence criterion) must be defined!")
 
-		if md.steadystate.requested_outputs:
-			md = checkfield(md,'steadystate.requested_outputs','cell',1)
+		md = checkfield(md,'steadystate.requested_outputs','stringrow',1)
 
 		return md
Index: issm/trunk-jpl/src/m/classes/stressbalance.m
===================================================================
--- issm/trunk-jpl/src/m/classes/stressbalance.m	(revision 16457)
+++ issm/trunk-jpl/src/m/classes/stressbalance.m	(revision 16458)
@@ -91,7 +91,5 @@
 			md = checkfield(md,'stressbalance.referential','size',[md.mesh.numberofvertices 6]);
 			md = checkfield(md,'stressbalance.loadingforce','size',[md.mesh.numberofvertices 3]);
-			if ~isempty(md.stressbalance.requested_outputs),
-				md = checkfield(md,'stressbalance.requested_outputs','size',[1 NaN]);
-			end
+			md = checkfield(md,'stressbalance.requested_outputs','stringrow',1);
 
 			%singular solution
Index: issm/trunk-jpl/src/m/classes/stressbalance.py
===================================================================
--- issm/trunk-jpl/src/m/classes/stressbalance.py	(revision 16457)
+++ issm/trunk-jpl/src/m/classes/stressbalance.py	(revision 16458)
@@ -123,6 +123,5 @@
 		md = checkfield(md,'stressbalance.referential','size',[md.mesh.numberofvertices,6])
 		md = checkfield(md,'stressbalance.loadingforce','size',[md.mesh.numberofvertices,3])
-		if md.stressbalance.requested_outputs:
-			md = checkfield(md,'stressbalance.requested_outputs','cell',1);
+		md = checkfield(md,'stressbalance.requested_outputs','stringrow',1);
 
 		#singular solution
Index: issm/trunk-jpl/src/m/classes/transient.m
===================================================================
--- issm/trunk-jpl/src/m/classes/transient.m	(revision 16457)
+++ issm/trunk-jpl/src/m/classes/transient.m	(revision 16458)
@@ -45,7 +45,5 @@
 			md = checkfield(md,'transient.isgia','numel',[1],'values',[0 1]);
 			md = checkfield(md,'transient.isdamage','numel',[1],'values',[0 1]);
-			if ~isempty(md.transient.requested_outputs),
-				md = checkfield(md,'transient.requested_outputs','size',[1 NaN]);
-			end
+			md = checkfield(md,'transient.requested_outputs','stringrow',1);
 
 		end % }}}
Index: issm/trunk-jpl/src/m/classes/transient.py
===================================================================
--- issm/trunk-jpl/src/m/classes/transient.py	(revision 16457)
+++ issm/trunk-jpl/src/m/classes/transient.py	(revision 16458)
@@ -56,6 +56,5 @@
 		md = checkfield(md,'transient.isgroundingline','numel',[1],'values',[0,1])
 		md = checkfield(md,'transient.isgia','numel',[1],'values',[0,1])
-		if md.transient.requested_outputs:
-			md = checkfield(md,'transient.requested_outputs','cell',1)
+		md = checkfield(md,'transient.requested_outputs','stringrow',1)
 
 		return md