Index: issm/trunk-jpl/test/NightlyRun/test120.m
===================================================================
--- issm/trunk-jpl/test/NightlyRun/test120.m	(revision 16471)
+++ issm/trunk-jpl/test/NightlyRun/test120.m	(revision 16472)
@@ -5,8 +5,11 @@
 md=setflowequation(md,'SSA','all');
 md.timestepping.time_step=0;
-md.cluster=generic('name',oshostname(),'np',3);
 md.initialization.waterfraction=zeros(md.mesh.numberofvertices,1);
 md.initialization.watercolumn=zeros(md.mesh.numberofvertices,1);
-md=solve(md,EnthalpySolutionEnum());
+md.thermal.isenthalpy = 1;
+md.thermal.isdynamicbasalspc = 1;
+
+md.cluster=generic('name',oshostname(),'np',3);
+md=solve(md,ThermalSolutionEnum());
 
 %Fields and tolerances to track changes
@@ -14,6 +17,6 @@
 field_tolerances={1e-13,1.45e-10,1e-13};
 field_values={...
-	(md.results.EnthalpySolution.Enthalpy),...
-	(md.results.EnthalpySolution.Waterfraction),...
-	(md.results.EnthalpySolution.Temperature),...
+	(md.results.ThermalSolution.Enthalpy),...
+	(md.results.ThermalSolution.Waterfraction),...
+	(md.results.ThermalSolution.Temperature),...
 	};
Index: issm/trunk-jpl/test/NightlyRun/test120.py
===================================================================
--- issm/trunk-jpl/test/NightlyRun/test120.py	(revision 16471)
+++ issm/trunk-jpl/test/NightlyRun/test120.py	(revision 16472)
@@ -15,8 +15,11 @@
 md=setflowequation(md,'SSA','all')
 md.timestepping.time_step=0
-md.cluster=generic('name',oshostname(),'np',3)
 md.initialization.waterfraction=numpy.zeros(md.mesh.numberofvertices)
 md.initialization.watercolumn=numpy.zeros(md.mesh.numberofvertices)
-md=solve(md,EnthalpySolutionEnum())
+md.thermal.isenthalpy = 1;
+md.thermal.isdynamicbasalspc = 1;
+
+md.cluster=generic('name',oshostname(),'np',3)
+md=solve(md,ThermalSolutionEnum())
 
 #Fields and tolerances to track changes
@@ -24,6 +27,6 @@
 field_tolerances=[1e-13,1.45e-10,1e-13]
 field_values=[\
-	md.results.EnthalpySolution.Enthalpy,\
-	md.results.EnthalpySolution.Waterfraction,\
-	md.results.EnthalpySolution.Temperature,\
+	md.results.ThermalSolution.Enthalpy,\
+	md.results.ThermalSolution.Waterfraction,\
+	md.results.ThermalSolution.Temperature,\
 	]
Index: issm/trunk-jpl/test/NightlyRun/test325.m
===================================================================
--- issm/trunk-jpl/test/NightlyRun/test325.m	(revision 16471)
+++ issm/trunk-jpl/test/NightlyRun/test325.m	(revision 16472)
@@ -5,8 +5,11 @@
 md=setflowequation(md,'SSA','all');
 md.timestepping.time_step=0.;
-md.cluster=generic('name',oshostname(),'np',3);
 md.initialization.waterfraction=zeros(md.mesh.numberofvertices,1);
 md.initialization.watercolumn=zeros(md.mesh.numberofvertices,1);
-md=solve(md,EnthalpySolutionEnum());
+md.thermal.isenthalpy = 1;
+md.thermal.isdynamicbasalspc = 1;
+
+md.cluster=generic('name',oshostname(),'np',3);
+md=solve(md,ThermalSolutionEnum());
 
 %Fields and tolerances to track changes
@@ -14,6 +17,6 @@
 field_tolerances={1e-13,1e-13,1e-13};
 field_values={...
-	(md.results.EnthalpySolution.Enthalpy),...
-	(md.results.EnthalpySolution.Waterfraction),...
-	(md.results.EnthalpySolution.Temperature),...
+	(md.results.ThermalSolution.Enthalpy),...
+	(md.results.ThermalSolution.Waterfraction),...
+	(md.results.ThermalSolution.Temperature),...
 	};
Index: issm/trunk-jpl/test/NightlyRun/test325.py
===================================================================
--- issm/trunk-jpl/test/NightlyRun/test325.py	(revision 16471)
+++ issm/trunk-jpl/test/NightlyRun/test325.py	(revision 16472)
@@ -15,8 +15,11 @@
 md=setflowequation(md,'SSA','all')
 md.timestepping.time_step=0.
-md.cluster=generic('name',oshostname(),'np',3)
 md.initialization.waterfraction=numpy.zeros((md.mesh.numberofvertices,1))
 md.initialization.watercolumn=numpy.zeros((md.mesh.numberofvertices,1))
-md=solve(md,EnthalpySolutionEnum())
+md.thermal.isenthalpy = 1
+md.thermal.isdynamicbasalspc = 1
+
+md.cluster=generic('name',oshostname(),'np',3)
+md=solve(md,ThermalSolutionEnum())
 
 #Fields and tolerances to track changes
@@ -24,6 +27,6 @@
 field_tolerances=[1e-13,1e-13,1e-13]
 field_values=[\
-	md.results.EnthalpySolution.Enthalpy,\
-	md.results.EnthalpySolution.Waterfraction,\
-	md.results.EnthalpySolution.Temperature,\
+	md.results.ThermalSolution.Enthalpy,\
+	md.results.ThermalSolution.Waterfraction,\
+	md.results.ThermalSolution.Temperature,\
 	]
Index: issm/trunk-jpl/test/NightlyRun/test411.py
===================================================================
--- issm/trunk-jpl/test/NightlyRun/test411.py	(revision 16471)
+++ issm/trunk-jpl/test/NightlyRun/test411.py	(revision 16472)
@@ -15,5 +15,5 @@
 md=setflowequation(md,'HO','all')
 md.cluster=generic('name',oshostname(),'np',3)
-md.timestepping.time_step=0
+md.timestepping.time_step=0.
 md=solve(md,SteadystateSolutionEnum())
 