Index: issm/trunk-jpl/src/m/enum/BoolElementResultEnum.m
===================================================================
--- issm/trunk-jpl/src/m/enum/BoolElementResultEnum.m	(revision 16486)
+++ 	(revision )
@@ -1,11 +1,0 @@
-function macro=BoolElementResultEnum()
-%BOOLELEMENTRESULTENUM - Enum of BoolElementResult
-%
-%   WARNING: DO NOT MODIFY THIS FILE
-%            this file has been automatically generated by src/c/shared/Enum/Synchronize.sh
-%            Please read src/c/shared/Enum/README for more information
-%
-%   Usage:
-%      macro=BoolElementResultEnum()
-
-macro=StringToEnum('BoolElementResult');
Index: issm/trunk-jpl/src/m/enum/DoubleElementResultEnum.m
===================================================================
--- issm/trunk-jpl/src/m/enum/DoubleElementResultEnum.m	(revision 16486)
+++ 	(revision )
@@ -1,11 +1,0 @@
-function macro=DoubleElementResultEnum()
-%DOUBLEELEMENTRESULTENUM - Enum of DoubleElementResult
-%
-%   WARNING: DO NOT MODIFY THIS FILE
-%            this file has been automatically generated by src/c/shared/Enum/Synchronize.sh
-%            Please read src/c/shared/Enum/README for more information
-%
-%   Usage:
-%      macro=DoubleElementResultEnum()
-
-macro=StringToEnum('DoubleElementResult');
Index: issm/trunk-jpl/src/m/enum/ElementResultEnum.m
===================================================================
--- issm/trunk-jpl/src/m/enum/ElementResultEnum.m	(revision 16486)
+++ 	(revision )
@@ -1,11 +1,0 @@
-function macro=ElementResultEnum()
-%ELEMENTRESULTENUM - Enum of ElementResult
-%
-%   WARNING: DO NOT MODIFY THIS FILE
-%            this file has been automatically generated by src/c/shared/Enum/Synchronize.sh
-%            Please read src/c/shared/Enum/README for more information
-%
-%   Usage:
-%      macro=ElementResultEnum()
-
-macro=StringToEnum('ElementResult');
Index: issm/trunk-jpl/src/m/enum/EnumDefinitions.py
===================================================================
--- issm/trunk-jpl/src/m/enum/EnumDefinitions.py	(revision 16486)
+++ issm/trunk-jpl/src/m/enum/EnumDefinitions.py	(revision 16487)
@@ -368,5 +368,4 @@
 def DoubleVecParamEnum(): return StringToEnum("DoubleVecParam")[0]
 def ElementEnum(): return StringToEnum("Element")[0]
-def ElementResultEnum(): return StringToEnum("ElementResult")[0]
 def ExternalResultEnum(): return StringToEnum("ExternalResult")[0]
 def FileParamEnum(): return StringToEnum("FileParam")[0]
@@ -514,16 +513,12 @@
 def TaylorHoodEnum(): return StringToEnum("TaylorHood")[0]
 def SaveResultsEnum(): return StringToEnum("SaveResults")[0]
-def BoolElementResultEnum(): return StringToEnum("BoolElementResult")[0]
 def BoolExternalResultEnum(): return StringToEnum("BoolExternalResult")[0]
-def DoubleElementResultEnum(): return StringToEnum("DoubleElementResult")[0]
 def DoubleExternalResultEnum(): return StringToEnum("DoubleExternalResult")[0]
 def DoubleMatExternalResultEnum(): return StringToEnum("DoubleMatExternalResult")[0]
 def IntExternalResultEnum(): return StringToEnum("IntExternalResult")[0]
 def JEnum(): return StringToEnum("J")[0]
-def PentaP1ElementResultEnum(): return StringToEnum("PentaP1ElementResult")[0]
 def StringExternalResultEnum(): return StringToEnum("StringExternalResult")[0]
 def StepEnum(): return StringToEnum("Step")[0]
 def TimeEnum(): return StringToEnum("Time")[0]
-def TriaP1ElementResultEnum(): return StringToEnum("TriaP1ElementResult")[0]
 def WaterColumnOldEnum(): return StringToEnum("WaterColumnOld")[0]
 def OutputdefinitionEnum(): return StringToEnum("Outputdefinition")[0]
Index: issm/trunk-jpl/src/m/enum/PentaP1ElementResultEnum.m
===================================================================
--- issm/trunk-jpl/src/m/enum/PentaP1ElementResultEnum.m	(revision 16486)
+++ 	(revision )
@@ -1,11 +1,0 @@
-function macro=PentaP1ElementResultEnum()
-%PENTAP1ELEMENTRESULTENUM - Enum of PentaP1ElementResult
-%
-%   WARNING: DO NOT MODIFY THIS FILE
-%            this file has been automatically generated by src/c/shared/Enum/Synchronize.sh
-%            Please read src/c/shared/Enum/README for more information
-%
-%   Usage:
-%      macro=PentaP1ElementResultEnum()
-
-macro=StringToEnum('PentaP1ElementResult');
Index: issm/trunk-jpl/src/m/enum/TriaP1ElementResultEnum.m
===================================================================
--- issm/trunk-jpl/src/m/enum/TriaP1ElementResultEnum.m	(revision 16486)
+++ 	(revision )
@@ -1,11 +1,0 @@
-function macro=TriaP1ElementResultEnum()
-%TRIAP1ELEMENTRESULTENUM - Enum of TriaP1ElementResult
-%
-%   WARNING: DO NOT MODIFY THIS FILE
-%            this file has been automatically generated by src/c/shared/Enum/Synchronize.sh
-%            Please read src/c/shared/Enum/README for more information
-%
-%   Usage:
-%      macro=TriaP1ElementResultEnum()
-
-macro=StringToEnum('TriaP1ElementResult');