Index: issm/trunk-jpl/src/c/classes/Params/Parameters.cpp
===================================================================
--- issm/trunk-jpl/src/c/classes/Params/Parameters.cpp	(revision 16509)
+++ issm/trunk-jpl/src/c/classes/Params/Parameters.cpp	(revision 16510)
@@ -524,5 +524,5 @@
 	}
 	if(found==-1){
-		/*still haven't found a list of petsc options, go find the default one, for analysis type NoneAnalysisEnum: */
+		/*still haven't found a list of petsc options, go find the default one, for analysis type DefaultAnalysisEnum: */
 		for(i=0;i<numanalyses;i++){
 			if(analyses[i]==DefaultAnalysisEnum){
Index: issm/trunk-jpl/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp	(revision 16509)
+++ issm/trunk-jpl/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp	(revision 16510)
@@ -30,5 +30,5 @@
 
 	/*Set toolkit to default*/
-	ToolkitsOptionsFromAnalysis(parameters,NoneAnalysisEnum);
+	ToolkitsOptionsFromAnalysis(parameters,DefaultAnalysisEnum);
 
 	if(migration_style==SoftMigrationEnum){
Index: issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h	(revision 16509)
+++ issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h	(revision 16510)
@@ -290,5 +290,4 @@
 	AdjointHorizAnalysisEnum,
 	AnalysisCounterEnum,
-	NoneAnalysisEnum,
 	DefaultAnalysisEnum,
 	BalancethicknessAnalysisEnum,
Index: issm/trunk-jpl/src/c/shared/Enum/EnumToStringx.cpp
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/EnumToStringx.cpp	(revision 16509)
+++ issm/trunk-jpl/src/c/shared/Enum/EnumToStringx.cpp	(revision 16510)
@@ -296,5 +296,4 @@
 		case AdjointHorizAnalysisEnum : return "AdjointHorizAnalysis";
 		case AnalysisCounterEnum : return "AnalysisCounter";
-		case NoneAnalysisEnum : return "NoneAnalysis";
 		case DefaultAnalysisEnum : return "DefaultAnalysis";
 		case BalancethicknessAnalysisEnum : return "BalancethicknessAnalysis";
Index: issm/trunk-jpl/src/c/shared/Enum/StringToEnumx.cpp
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/StringToEnumx.cpp	(revision 16509)
+++ issm/trunk-jpl/src/c/shared/Enum/StringToEnumx.cpp	(revision 16510)
@@ -302,5 +302,4 @@
 	      else if (strcmp(name,"AdjointHorizAnalysis")==0) return AdjointHorizAnalysisEnum;
 	      else if (strcmp(name,"AnalysisCounter")==0) return AnalysisCounterEnum;
-	      else if (strcmp(name,"NoneAnalysis")==0) return NoneAnalysisEnum;
 	      else if (strcmp(name,"DefaultAnalysis")==0) return DefaultAnalysisEnum;
 	      else if (strcmp(name,"BalancethicknessAnalysis")==0) return BalancethicknessAnalysisEnum;
@@ -383,9 +382,9 @@
 	      else if (strcmp(name,"Element")==0) return ElementEnum;
 	      else if (strcmp(name,"ExternalResult")==0) return ExternalResultEnum;
+	      else if (strcmp(name,"FileParam")==0) return FileParamEnum;
          else stage=4;
    }
    if(stage==4){
-	      if (strcmp(name,"FileParam")==0) return FileParamEnum;
-	      else if (strcmp(name,"Input")==0) return InputEnum;
+	      if (strcmp(name,"Input")==0) return InputEnum;
 	      else if (strcmp(name,"IntInput")==0) return IntInputEnum;
 	      else if (strcmp(name,"InputToExtrude")==0) return InputToExtrudeEnum;
@@ -506,9 +505,9 @@
 	      else if (strcmp(name,"HydrologyWaterVx")==0) return HydrologyWaterVxEnum;
 	      else if (strcmp(name,"HydrologyWaterVy")==0) return HydrologyWaterVyEnum;
+	      else if (strcmp(name,"StressTensor")==0) return StressTensorEnum;
          else stage=5;
    }
    if(stage==5){
-	      if (strcmp(name,"StressTensor")==0) return StressTensorEnum;
-	      else if (strcmp(name,"StressTensorxx")==0) return StressTensorxxEnum;
+	      if (strcmp(name,"StressTensorxx")==0) return StressTensorxxEnum;
 	      else if (strcmp(name,"StressTensorxy")==0) return StressTensorxyEnum;
 	      else if (strcmp(name,"StressTensorxz")==0) return StressTensorxzEnum;
Index: issm/trunk-jpl/src/m/enum/EnumDefinitions.py
===================================================================
--- issm/trunk-jpl/src/m/enum/EnumDefinitions.py	(revision 16509)
+++ issm/trunk-jpl/src/m/enum/EnumDefinitions.py	(revision 16510)
@@ -288,5 +288,4 @@
 def AdjointHorizAnalysisEnum(): return StringToEnum("AdjointHorizAnalysis")[0]
 def AnalysisCounterEnum(): return StringToEnum("AnalysisCounter")[0]
-def NoneAnalysisEnum(): return StringToEnum("NoneAnalysis")[0]
 def DefaultAnalysisEnum(): return StringToEnum("DefaultAnalysis")[0]
 def BalancethicknessAnalysisEnum(): return StringToEnum("BalancethicknessAnalysis")[0]
Index: issm/trunk-jpl/src/m/enum/NoneAnalysisEnum.m
===================================================================
--- issm/trunk-jpl/src/m/enum/NoneAnalysisEnum.m	(revision 16509)
+++ 	(revision )
@@ -1,11 +1,0 @@
-function macro=NoneAnalysisEnum()
-%NONEANALYSISENUM - Enum of NoneAnalysis
-%
-%   WARNING: DO NOT MODIFY THIS FILE
-%            this file has been automatically generated by src/c/shared/Enum/Synchronize.sh
-%            Please read src/c/shared/Enum/README for more information
-%
-%   Usage:
-%      macro=NoneAnalysisEnum()
-
-macro=StringToEnum('NoneAnalysis');